#include "Memory/util/CacheUtils.h"

namespace TimingAnalysisPass {

unsigned getCachelineMemoryLatency(CacheType type)
{
	/* TODO maybe rename the function and return "Latency+PerWordLatency" in
	 * case of no cache? */
	assert (MemTopType == MemoryTopologyType::SEPARATECACHES && "This function cannot be used without caches");

	unsigned numWords;
	switch (type) {
	case CacheType::UNIFIED:
	        assert(Ilinesize == Dlinesize);
	        /* fallthrough */
	case CacheType::INSTRUCTION:
	        assert (Ilinesize % 4 == 0);
	        numWords = Ilinesize/4;
	        break;
	case CacheType::DATA:
	        assert (Dlinesize % 4 == 0);
	        numWords = Dlinesize/4;
	        break;
	default:
	        assert(0 && "UNREACHABLE");
	}
	return Latency + PerWordLatency*numWords;
}

}
